﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.Common;

namespace HeuristicLab.DataImporter.DbExplorer.Interfaces {
  public abstract class DbConnectionBase {
    private string databaseName;
    public string DatabaseName {
      get { return this.databaseName; }
      set { this.databaseName = value; }
    }

    private string userName;
    public string UserName {
      get { return this.userName; }
      set { this.userName = value; }
    }

    private string password;
    public string Password {
      get { return this.password; }
      set { this.password = value; }
    }
    
    protected DbConnectionBase(string databaseName, string userName, string password) {
      this.databaseName = databaseName;
      this.userName = userName;
      this.password = password;
    }

    public abstract DbConnection CreateConnection();
    public abstract bool TestConnection();

    private string errorMessage;
    public string ErrorMessage {
      get { return this.errorMessage; }
      protected set { this.errorMessage = value; }
    }
  }
}
